/*
    Bitmuster.java
    gvpr ws99/2ooo, bungsblatt 6

    Copyright (C) 1999  Thomas Kindler (tk)
    e-mail: thomas.kindler@gmx.de

    todo: -

    19.11.99: tk, initial version.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

class Bitmuster {

  // Wandelt einen Integer in einen String im
  // Binrformat um. Fhrende Nullen werden 
  // weggelassen, n=0 wird als einzelne "0" 
  // dargestellt.
  //  
  public static String ToBinString( int n )  {
    String s = "";
    do {
      s = ( ((n & 1) !=0) ? "1" : "0") + s;
      n >>>= 1; 
    } while (n != 0);
    
    return s;  
  }

  
  public static void main( String argv[] ) {    

    System.out.println( "        3 = " + ToBinString(3)         + "b" );
    System.out.println( "     -523 = " + ToBinString(-523)      + "b" );
    System.out.println( "    16015 = " + ToBinString(16015)     + "b" );
    System.out.println( "214783648 = " + ToBinString(214783648) + "b" );

    System.out.println( ToBinString( -86 ) );
    System.out.println( ToBinString( -86 >> 1) );
    
    System.out.println( -86 >>  1);
    System.out.println( (byte)((byte)-86) >>> 1 );
  
    
    /* Ausgabe:
               3 = 11b
            -523 = 11111111111111111111110111110101b
           16015 = 11111010001111b
       214783648 = 1100110011010101011010100000b
    */
  }

}