/*  Test.java
    gvpr ws99/2ooo, bungsblatt 11.3

    Copyright (C) 2000  Thomas Kindler (tk)
    e-mail: thomas.kindler@gmx.de

    todo: -

    14.01.00: tk, irgendwie ist es dumm von Java, darauf zu bestehen 
                  jede als public deklarierte Klasse in ein eigenes 
                  .java file zu packen. Die Exceptions wren z.B. besser
                  in einem gemeinsamen exceptions.java file oder so
                  aufgehoben. :(
    14.01.00: tk, initial version.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version. Read the
    full License at http://www.gnu.org/copyleft for more details.
*/

class Test {

  public static void main( String args[] ) {
    
    BoundedContainer  container;
    Iterator          i;
    
    container = new ListContainer();
    container.addElement( "Hallo, ich bin eine " );
    container.addElement( "verkettete Liste!\n" );
    
    i = container.getElements();
    while (i.hasNextElement())
      System.out.print( i.getNextElement() );

    container.addElement( "  Man darf diese Liste sogar verndern, ohne einen neuen\n" );
    container.addElement( "  Iterator anzufordern. Das ist aber nur deshalb mglich,\n" );
    container.addElement( "  weil nur am Ende der Liste neue Elemente angefgt werden;\n" );
    container.addElement( "  Beim lschen von Elementen knnten ble Inkonsistenzen\n" );
    container.addElement( "  zwischen Liste und Iterator entstehen.\n" );

    try {
      for(;;)
        System.out.print( i.getNextElement() );
    } catch (Exception e) {
      System.out.println( e );
    }

    System.out.println( container.getNumberOfElements() + " von " + 
                        container.getMaxCapacity() + " Elementen belegt.\n\n" );
    
    container = new ArrayContainer( 5 );
    container.addElement( "Ich bin ein ArrayContainer!\n" );
    container.addElement( "  Leider ist in mir nicht ganz so viel Platz wie\n" );
    container.addElement( "  in der Liste, und daher kann die addElement() Methode\n" );
    container.addElement( "  auch mit Exceptions um sich werfen. Zum Beispiel in\n" );
    container.addElement( "  der nchsten Zeile.\n" );

    i = container.getElements();
    while (i.hasNextElement())
      System.out.print( i.getNextElement() );

    try {  
      container.addElement( "hab ich's nicht gesagt ?!?..." );
    } catch (Exception e)  {
      System.out.println( e );
    }
  }
}

/* Ausgabe:

    Hallo, ich bin eine verkettete Liste!
      Man darf diese Liste sogar verndern, ohne einen neuen
      Iterator anzufordern. Das ist aber nur deshalb mglich,
      weil nur am Ende der Liste neue Elemente angefgt werden;
      Beim lschen von Elementen knnten ble Inkonsistenzen
      zwischen Liste und Iterator entstehen.
    NoNextElementException
    7 von 2147483647 Elementen belegt.


    Ich bin ein ArrayContainer!
      Leider ist in mir nicht ganz so viel Platz wie
      in der Liste, und daher kann die addElement() Methode
      auch mit Exceptions um sich werfen. Zum Beispiel in
      der nchsten Zeile.
    TooManyElementsException
    Normal Termination
*/
