/*
    Strasse.java
    gvpr ws99/2ooo, bungsblatt 8

    Copyright (C) 1999  Thomas Kindler (tk)
    e-mail: thomas.kindler@gmx.de

    todo: -

    2.12.99: tk, initial version.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/



abstract class Geschaeft {
    
  private String name;
  
  public Geschaeft() { 
    name = "unbenannt";  
  }
  
  public Geschaeft( String n ) { 
    name = n;            
  }  
  
  public String GibName() { 
    return name;         
  }
  
  public abstract void ZeigeAngebot();  
}


class HiFiLaden extends Geschaeft {
  
  public HiFiLaden( String n ) {
    super(n);
  }

  public void ZeigeAngebot() {
    System.out.println( "Warenangebot von " + GibName() + ":\n" +
                        "  Plattenspieler\n" +
                        "  CD-Player\n" );
  }
}


class Schuhladen extends Geschaeft {
  
  public Schuhladen( String n ) {
    super(n);
  }

  public void ZeigeAngebot() {
    System.out.println( "Warenangebot von " + GibName() + ":\n" +
                        "  Damenschuhe\n" +
                        "  Herrenschuhe\n"+
                        "  Kinderschuhe\n" );
  }
}


class Eisdiele extends Geschaeft {
  
  public Eisdiele( String n ) {
    super(n);
  }

  public void ZeigeAngebot() {
    System.out.println( "Warenangebot von " + GibName() + ":\n" +
                        "  Groes Eis\n" +
                        "  Kaltes Eis\n" );
  }
}


class Buchhandlung extends Geschaeft {
  
  public Buchhandlung( String n ) {
    super(n);
  }

  public void ZeigeAngebot() {
    System.out.println( "Warenangebot von " + GibName() + ":\n" +
                        "  Bjarne Stroustrup, The c++ programming language\n" +
                        "  Robert Sedgewick, Algorithms in C\n"+
                        "  Michael Abrash, Graphics Programming Black Book\n" );
  }
}


class Spielegeschaeft extends Geschaeft {
  
  public Spielegeschaeft( String n ) {
    super(n);
  }

  public void ZeigeAngebot() {
    System.out.println( "Warenangebot von " + GibName() + ":\n" +
                        "  Q3A!!!\n" +
                        "  Q3A!!!!!\n"+
                        "  Q3A!!!!!!!\n" );
  }
}


class Strasse  {

  public static void main( String args[] )  {

    Geschaeft[] strasse = new Geschaeft[5];
    
    strasse[0] = new Spielegeschaeft ( "ShubNiggurath's painkeep" );
    strasse[1] = new Buchhandlung( "Amazon" );
    strasse[2] = new Eisdiele( "Oh nein, noch eine Eisdiele(tm)" );
    strasse[3] = new Schuhladen( "Meiers Schuhladen"   );
    strasse[4] = new HiFiLaden( "Muellers HiFi-World" );

    for (int i=0; i<strasse.length; i++)
      strasse[i].ZeigeAngebot();

  }

  /* Ausgabe:

      Warenangebot von ShubNiggurath's painkeep:
        Q3A!!!
        Q3A!!!!!
        Q3A!!!!!!!
      
      Warenangebot von Amazon:
        Bjarne Stroustrup, The c++ programming language
        Robert Sedgewick, Algorithms in C
        Michael Abrash, Graphics Programming Black Book
            
      Warenangebot von Oh nein, noch eine Eisdiele(tm):
        Groes Eis
        Kaltes Eis
      
      Warenangebot von Meiers Schuhladen:
        Damenschuhe
        Herrenschuhe
        Kinderschuhe
      
      Warenangebot von Muellers HiFi-World:
        Plattenspieler
        CD-Player
  */

}