/*
    Rekursion.java
    gvpr ws99/2ooo, bungsblatt 7

    Copyright (C) 1999  Thomas Kindler (tk)
    e-mail: thomas.kindler@gmx.de

    todo: -

    25.11.99: tk, initial version.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

class Rekursion  {

  // Aufgabe 7.1 - Berechnet alle Quadratzahlen 
  // zwischen 1 und 25 mit for(..) und while(..) 
  // Schleife.
  //
  static void QuadratFor()  {

    for ( int i = 1; i*i <= 25; i++ )
      System.out.println( i*i );  
  }
  
  
  static void QuadratWhile()  {

    int i = 1;

    while (i*i <= 25)  {
      System.out.println( i*i );
      i++;
    }
  }
  
  
  // Aufgabe 7.2a - Berechnet merkwrdig
  // geordnete Produktreihen :)
  //
  static void Produkte( int i, int j ) {
   
    System.out.println ( i + "*" + j + "=" + i*j ); 
    
    if (j > 0)
      Produkte( i, j-1 );
    else 
      if (i < 2)
        Produkte( i+1, 2 );
      
    return;
  }
  
    
  // Aufgabe 7.2b - Fibonaccizahlen
  //   
  // !! Anmerkung: Hier hat sich auf dem bungsblatt
  // ein Fehler eingeschlichen... nach dem Test auf (n<0)
  // mte es korrekt heien: "Eingabe muss >= 0 sein!"
  //
  static int FibonacciZahl(int n) { 
    int a, b;

    if (n < 0) { 
      System.out.println( "Eingabe muss >= 0 sein!" ); 
      System.exit (1); 
    } 

    a=1;  b=1;    
    while (n-- > 1) {
      a += b; 
      b  = a - b;   
    }
      
    return a;
  }


  static void main( String argv[] )  {
    System.out.println( "Quadrate (for)  : " );
    QuadratFor();

    System.out.println( "Quadrate (while): " );
    QuadratWhile(); 
    
    System.out.println( "Produkte:" );
    Produkte( 0, 2 );  

    System.out.println( "Die Fibonacci-Zahl von 10 ist: " +
                        FibonacciZahl(10) );

    
    /* Ausgabe:
        Quadrate (for)  : 1, 4, 9, 16, 25
        Quadrate (while): 1, 4, 9, 16, 25
        Produkte: 0*2=0, 0*1=0, 0*0=0,
                  1*2=2, 1*1=1, 1*0=0,
                  2*2=4, 2*1=2, 2*0=0
        Die Fibonacci-Zahl von 10 ist: 89
    */    
  }
}