
public  class  ListContainer
        implements  BoundedContainer 
{
  protected ListNode  head, tail;
  protected int       size;

  
  public ListContainer()  {
    head = new ListNode( null );
    tail = head;
    size = 0;
  }
              
  public int  getMaxCapacity()  {
    // Die Liste kann prinzipiell beliebig lang 
    // werden, daher liefert sie den grtmglichen 
    // Wert zurck.
    //
    return  Integer.MAX_VALUE;
  }

  public int  getNumberOfElements()  {
    return  size;
  }

  public void  addElement( Object object )  {
    tail = new ListNode( object, tail );
    size++;
  }

  public Iterator  getElements()  {
    return new ListIterator();
  }


  protected  class  ListNode {
    Object    object;
    ListNode  next;

    // Erzeugt eine neue, nicht verbundene Node 
    //
    ListNode( Object object ) {
      this.object = object;
      next   = null;
    }

    // Hngt die neue Node an einen vorgnger
    //    
    ListNode( Object object, ListNode prev )  {
      this ( object );
      prev.next = this;
    }
  }

  
  protected  class  ListIterator  
           implements Iterator  
  {
    ListNode  current = head;

    public  Object  getNextElement()  {
      if (current.next == null)
        throw new NoNextElementException();
      
      current = current.next;  
      return  current.object;
    }

    public  boolean hasNextElement()  {
      return  current.next != null;
    }
  }
}