/*  
    Euklid.java
 
    euklid's gcd algorithm

    - do not distribute - colonelcrusher@gmx.net
  
    todo: -

    25.10.99: tk, initial version.

    Copyright (c)1999 by Thomas Kindler aka cc/kreaPC.
    All rights reserved.
 
    This software may be freely copied, modified and redistributed without
    fee for non-commerical purposes provided that this copyright notice is
    preserved intact on all copies and modified copies.
 
    There is no warranty or other guarantee of fitness of this software.
    It is provided solely "as is". The author(s) disclaim(s) all
    responsibility and liability with respect to this software's usage
    or its effect upon hardware or computer systems.
*/

public class Euklid  {
  
  static long gcd( long a, long b ) {

    while (b!=0)  {          
      long q = a / b;        // unnecessary for gcd calculation
      long r = a % b;        

      System.out.println( "a="+a+", b="+b+", q="+q+", r="+r );
      
      a = b;   b = r;
    }
                
    return a;
  }
      
  static void main( String[] args )  {
    long a, b, c;
    
    a = 3213445;
    b =  654875;

    System.out.println( "euklid's gcd algorithm" );        

    c = gcd(a,b);
 
    System.out.println( "  gcd(a,b) = " + c       );
    System.out.println( "  lcm(a,b) = " + (a*b)/c );
  }

}