/*
    InchKonv.java
    gvpr ws99/2ooo, bungsblatt 6

    Copyright (C) 1999  Thomas Kindler (tk)
    e-mail: thomas.kindler@gmx.de

    todo: -

    02.12.99: tk, fehler in InchToCm() behoben, bei dem Yard und
                  Foot verdreht wurden, auerdem sieht CmToInch()
                  jetzt etwas eleganter aus.
    19.11.99: tk, initial version.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

class InchKonv {
  
  public static String CmToInch( float cm )  {
    float  inch; 
    int    foot, yard;
    
    yard = (int)Math.floor( cm/2.54 / 12 / 3 );
    cm  -= yard * 3 * 12 * 2.54;
    
    foot = (int)Math.floor( cm/2.54 / 12 );
    cm  -= foot * 12 * 2.54;
    
    inch = cm/2.54f;
           
    return yard + "\'" + foot + "\'" + inch + "\"";
  }  
    
  public static String InchToCm( int yard, int foot, float inch ) {

    // Simple Umrechnung...
    //
    return (yard*3*12*2.54 + foot*12*2.54 + inch*2.54) + "cm";  
  }
      
  public static void main( String args[] )  {

    System.out.println(    "    100cm = " + CmToInch(       100 ) );
    System.out.println(    "386.486cm = " + CmToInch(  386.486f ) );
    System.out.println( "   1\'2\'7\" = " + InchToCm(   1, 2, 7 ) );
    System.out.println( " 13\'1\'11\" = " + InchToCm( 13, 1, 11 ) );

    /* Ausgabe:
            100cm = 1'0'3.370079"
        386.486cm = 4'0'8.15984"
           1'2'7" = 170.18cm
         13'1'11" = 1247.14cm
    */    
  }
}
