/*  ADT Insertion Sort  */

import java.util.*;

class InsertionSort {
  
  public static void Sort( Vector data ) {
        
    for (int i=0; i<data.size(); i++)  {

      int k = 0;

      for ( k=0; k<i; k++ )
        if ( ((Comparable)data.elementAt(i)).
               compareTo( 
                 ((Comparable)data.elementAt(k)) 
               ) < 0 
           )
          break;        
      
        if ( k != i )  {
          Object merker = data.elementAt(i);
                    
          for (int j=i; j>k; j--)
            data.setElementAt( data.elementAt(j-1), j );

          data.setElementAt( merker, k );
        }
    }
  }
  
  public static void main( String argv[] ) {
    
    Vector data;
    Random rnd;
                        
    System.out.println( "Namen sortieren:" );

    data = new Vector();
    data.add( "Samira" );
    data.add( "Daniel" );
    data.add( "Thomas" );
    data.add( "Meike" );
    data.add( "Michael" );
    data.add( "Prof. Dr. Gruhn" );
    data.add( "Anita" );
    data.add( "Melanie" );
    
    Sort( data );
        
    for (int i=0; i<data.size(); i++)
      System.out.println( i + ": " + data.elementAt(i) );

    // ----------
    // 
        
    System.out.println( "Zufallszahlen sortieren:" );

    rnd  = new Random();
    data = new Vector();
    
    for (int i=0; i<20; i++)
      data.add( new Integer(rnd.nextInt()) );
    
    Sort(data);      

    for (int i=0; i<data.size(); i++)
      System.out.println( i + ": " + data.elementAt(i) );
  }
}
